﻿using System;
using System.Net.Http;
using System.Threading;
using System.Threading.Tasks;
using System.Web.Http;

namespace lecture4.Controllers
{
    [RoutePrefix("hello")]
    public class HelloController : ApiController
    {
        [HttpGet]
        [Route("")]
        public async Task<IHttpActionResult> HelloWorld()
        {
            // Return using async
            var resultStatus = await HelloService.DoSomethingAsync();
            
            // Block context thread (results in deadlock)
            // var resultStatus = HelloService.DoSomethingAsync().Result;
            
            // This can be invoked from a non-async method
            //var resultStatus = Task.Run(() => HelloService.DoSomethingAsync()).Result;

            return Ok(new { StatusCode = resultStatus});
        }
    }

    public class HelloService
    {
        public static async Task<string> DoSomethingAsync()
        {
            return await HelloRepository.DoSomethingAsync();
        }
    }

    public class HelloRepository
    {
        public static async Task<string> DoSomethingAsync()
        {
            using (var client = new HttpClient())
            {
                client.BaseAddress = new Uri("http://www.google.com/");

                // Request google
                var result = await client.GetAsync("?q=dotnet");

                return result.StatusCode.ToString();
            }
        }
    }
}